#!/bin/bash

cd ~/catkin_ws


echo "testing ..."
echo ""

chmod +x ~/catkin_ws/src/semesterprojekt/src/sim/location_monitor/scripts/bot_listener.py
chmod +x ~/catkin_ws/src/semesterprojekt/src/sim/location_monitor/scripts/location_monitor_node.py

type=$(cat ~/catkin_ws/src/semesterprojekt/build/sim/botname.txt)

if [ "$type" = "burger" ]
	
	then

	botradius=0.069

	else

	botradius=0.1405

fi

c=0

cd ~/catkin_ws/src/semesterprojekt/build/test/testfaelle

testfall=$(find ./ -name "$c")

while [ -f $testfall/test.world ]; do

	echo "test$c"
	echo ""

	timeout=$(grep -i "timeout" $testfall/config.ini | tr -d -c 0-9.)
	rightBorder=$(grep -i "rangeRightBorder=" $testfall/config.ini | tr -d -c 0-9.)
	leftBorder=$(grep -i "rangeLeftBorder=" $testfall/config.ini | tr -d -c 0-9.)

	

	dist=$(bc -l <<< "scale=10; ($rightBorder-$leftBorder)")

	cp $testfall/test.world ~/catkin_ws/src/semesterprojekt/build/sim/worlds/test.world

	#configuring launch file

	echo '<launch>
  <arg name="model" default="$(env TURTLEBOT3_MODEL)" doc="model type [burger, waffle, waffle_pi]"/>
  <arg name="x_pos" default="0"/>
  <arg name="y_pos" default="5"/>
  <arg name="z_pos" default="-0.001001"/>

  <include file="$(find gazebo_ros)/launch/empty_world.launch">
    <arg name="world_name" value="$(find sim)/worlds/test.world"/>
    <arg name="paused" value="false"/>
    <arg name="use_sim_time" value="true"/>
    <arg name="gui" value="true"/>
    <arg name="headless" value="false"/>
    <arg name="debug" value="false"/>
  </include>

  <param name="robot_description" command="$(find xacro)/xacro --inorder $(find turtlebot3_description)/urdf/turtlebot3_$(arg model).urdf.xacro" />

  <node pkg="gazebo_ros" type="spawn_model" name="spawn_urdf" args="-urdf -model turtlebot3_$(arg model) -x $(arg x_pos) -y $(arg y_pos) -z $(arg z_pos) -param robot_description" />
</launch>' > ~/catkin_ws/src/semesterprojekt/build/sim/sim.launch

	#Launch Welt
	gnome-terminal -- bash -c 'cd ~/catkin_ws; source devel/setup.bash; export TURTLEBOT3_MODEL='$type'; roslaunch sim sim.launch; sleep 5'

	#bot_listener
	sleep 1
	gnome-terminal -- bash -c 'cd ~/catkin_ws; source devel/setup.bash; cd ~/catkin_ws/src/semesterprojekt/build/sim/log; rosrun location_monitor bot_listener.py;'

	#location_monitor
#	gnome-terminal -- bash -c 'cd ~/catkin_ws; source devel/setup.bash; cd ~/catkin_ws/src/semesterprojekt/build/sim/log; rosrun location_monitor location_monitor_node.py '$botradius' '$dist' 500 '$timeout';'

	#Launch Test
	gnome-terminal -- bash -c 'cd ~/catkin_ws; source devel/setup.bash; export TURTLEBOT3_MODEL=burger; rosrun sim turtlebot3_obstacle '$dist';'




	

	cd ~/catkin_ws; source devel/setup.bash
	cd ~/catkin_ws/src/semesterprojekt/build/sim/log

	echo 'Location_Monitor:'
	echo ''

	rosrun location_monitor location_monitor_node.py $botradius $dist 500 $timeout

#	if ( rosrun location_monitor location_monitor_node.py $botradius $dist 500 $timeout & ) | grep -q -m 1 'Collision\|Stop\|Timeout'; 			then
   		
#		ps ax | grep -i python | awk {'print $1'} | xargs kill -9
#		ps ax | grep -i gzclient | awk {'print $1'} | xargs kill -9
#		ps ax | grep -i gzserver | awk {'print $1'} | xargs kill -9

#	fi

#	sleep 30

	ps ax | grep -i python | awk {'print $1'} | xargs kill -9 > /dev/null 2> /dev/null || :
	ps ax | grep -i gzclient | awk {'print $1'} | xargs kill -9 > /dev/null 2> /dev/null || :
	ps ax | grep -i gzserver | awk {'print $1'} | xargs kill -9 > /dev/null 2> /dev/null || :

	mv ~/catkin_ws/src/semesterprojekt/build/sim/log/bot_listener.log ~/catkin_ws/src/semesterprojekt/build/sim/log/bl$c.log

	mv ~/catkin_ws/src/semesterprojekt/build/sim/log/location_monitor.log ~/catkin_ws/src/semesterprojekt/build/sim/log/lm$c.log	

	let c=c+1

	cd ~/catkin_ws/src/semesterprojekt/build/test/testfaelle

	testfall=$(find ./ -name "$c")


done

cd ~/catkin_ws

echo ""
echo "Done"
